<script setup lang="ts">
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Material } from '@/types/Material'
import { useStockStore } from '@/stores/stock'
import { useRoute } from 'vue-router'

const route = useRoute()
const stockStore = useStockStore()

const search = ref('')
const initilMaterial: Material = {
  id: -1,
  name: '',
  price: 0,
  unit: 0,
  min: 0,
  types: ['pack']
}

let editedIndex = -1
const dialogDelete = ref(false)
const dialog = ref(false)
const form = ref(false)
const refform = ref<VForm | null>(null)
const loading = ref(false)
let latestId = 11

const editedMaterial = ref<Material>(JSON.parse(JSON.stringify(initilMaterial)))

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMaterial.value = Object.assign({}, initilMaterial)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(stockStore.materials[editedIndex], editedMaterial.value)
  } else {
    editedMaterial.value.id = latestId++
    stockStore.materials.push(editedMaterial.value)
  }
  closeDialog()
}

function editItem(item: Material) {
  editedIndex = stockStore.materials.indexOf(item)
  editedMaterial.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Material) {
  editedIndex = stockStore.materials.indexOf(item)
  editedMaterial.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  stockStore.materials.splice(editedIndex, 1)
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMaterial.value = Object.assign({}, initilMaterial)
  })
  editedIndex = -1
}

onMounted(() => {
  stockStore.initialize()
})
</script>

<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <v-toolbar flat style="background-color: #212121; color: white">
    <v-toolbar-title>Stock Management</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon style="background-color: #212121" color="white">
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="CheckStock"
              :class="{ active: route.name === 'checkstock' }"
              :to="{ path: '/CheckStock' }"
              rounded="0"
              >CheckStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="OrderStock"
              :class="{ active: route.name === 'orderstock' }"
              :to="{ path: '/OrderStock' }"
              rounded="0"
              >OrderStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
    <!--Delete Dialog-->
    <v-dialog v-model="dialogDelete" width="500px">
      <v-card>
        <br />
        <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
        <v-spacer></v-spacer>
        <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
        <v-card-title align="center" class="text-h10">
          This action cannot be undone.<br />
          All values associated with this field will be lost.
        </v-card-title>
        <v-spacer></v-spacer>
        <div align="center">
          <div style="margin: 0 auto; max-width: 400px">
            <v-btn
              block
              style="background-color: #e11d48"
              color="white"
              variant="text"
              @click="deleteItemConfirm()"
            >
              Delete field
            </v-btn>
          </div>
        </div>
        <div align="center">
          <div
            style="
              margin: 0 auto;
              max-width: 400px;
              border: 1px solid #dfe1e6;
              border-radius: 5px;
              margin-top: 10px;
            "
          >
            <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
          </div>
        </div>
        <v-spacer></v-spacer>
        <br />
      </v-card>
    </v-dialog>
  </v-toolbar>
  <div>
    <v-data-table
      v-model:search="search"
      :headers="stockStore.headers"
      :items="stockStore.materials"
    >
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
    <v-row>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col>
        <v-dialog v-model="dialog" persistent width="600">
          <template v-slot:activator="{ props }">
            <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
              New Material
            </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5">Material</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refform" v-model="form" @submit.prevent="stockStore.onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="12">
                      <v-text-field
                        v-model="editedMaterial.name"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Name"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="editedMaterial.price"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        clearable
                        label="Price"
                        placeholder="Enter Price"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="12" md="6">
                      <v-text-field
                        v-model="editedMaterial.min"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Minimum"
                      ></v-text-field>
                    </v-col>

                    <v-col cols="12" sm="6" md="4">
                      <v-combobox
                        v-model="editedMaterial.types"
                        :items="[
                          { title: 'pack', value: 'pack' },
                          { title: 'bottle', value: 'bottle' }
                        ]"
                        label="Select Types of Material"
                        :return-object="false"
                      ></v-combobox>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small>*indicates required field</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
              <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
    </v-row>
  </div>
</template>

<style scoped></style>
